Index: Makefile.inc1
===================================================================
--- Makefile.inc1	(revision 261329)
+++ Makefile.inc1	(working copy)
@@ -234,7 +234,7 @@
 		SSP_CFLAGS= \
 		-DWITHOUT_HTML -DWITHOUT_INFO -DNO_LINT -DWITHOUT_MAN \
 		-DNO_PIC -DWITHOUT_PROFILE -DNO_SHARED \
-		-DNO_CPU_CFLAGS -DNO_WARNS -DNO_CTF
+		-DNO_CPU_CFLAGS -DNO_WARNS -DNO_CTF -DEARLY_BUILD
 
 # build-tools stage
 TMAKE=		MAKEOBJDIRPREFIX=${OBJTREE} \
@@ -243,13 +243,28 @@
 		DESTDIR= \
 		SSP_CFLAGS= \
 		BOOTSTRAPPING=${OSRELDATE} -DNO_LINT -DNO_CPU_CFLAGS \
-		-DNO_WARNS -DNO_CTF
+		-DNO_WARNS -DNO_CTF -DEARLY_BUILD
 
 # cross-tools stage
 XMAKE=		TOOLS_PREFIX=${WORLDTMP} ${BMAKE} \
 		TARGET=${TARGET} TARGET_ARCH=${TARGET_ARCH} \
 		-DWITHOUT_GDB
 
+# kernel-tools stage
+KTMAKEENV=	INSTALL="sh ${.CURDIR}/tools/install.sh" \
+		PATH=${BPATH}:${PATH} \
+		WORLDTMP=${WORLDTMP} \
+		VERSION="${VERSION}" \
+		COMPILER_TYPE=${COMPILER_TYPE}
+KTMAKE=		TOOLS_PREFIX=${WORLDTMP} MAKEOBJDIRPREFIX=${WORLDTMP} \
+		${KTMAKEENV} ${MAKE} ${WORLD_FLAGS} -f Makefile.inc1 \
+		DESTDIR= \
+		BOOTSTRAPPING=${OSRELDATE} \
+		SSP_CFLAGS= \
+		-DWITHOUT_HTML -DWITHOUT_INFO -DNO_LINT -DWITHOUT_MAN \
+		-DNO_PIC -DNO_PROFILE -DNO_SHARED \
+		-DNO_CPU_CFLAGS -DNO_WARNS -DNO_CTF -DEARLY_BUILD
+
 # world stage
 WMAKEENV=	${CROSSENV} \
 		_SHLIBDIRPREFIX=${WORLDTMP} \
@@ -469,7 +484,7 @@
 .for _dir in lib/ncurses/ncurses lib/ncurses/ncursesw lib/libmagic
 	cd ${.CURDIR}/${_dir}; \
 	    MAKEOBJDIRPREFIX=${OBJTREE}/lib32 ${MAKE} SSP_CFLAGS= DESTDIR= \
-	    DIRPRFX=${_dir}/ build-tools
+	    DIRPRFX=${_dir}/ -DNO_CTF -DEARLY_BUILD build-tools
 .endfor
 	cd ${.CURDIR}; \
 	    ${LIB32WMAKE} -f Makefile.inc1 libraries
@@ -779,7 +794,8 @@
 	cd ${KRNLOBJDIR}/${_kernel}; \
 	    PATH=${BPATH}:${PATH} \
 	    MAKESRCPATH=${KERNSRCDIR}/dev/aic7xxx/aicasm \
-	    ${MAKE} SSP_CFLAGS= -DNO_CPU_CFLAGS -DNO_CTF \
+	    MAKEINCPATH=${WORLDTMP}/usr/include \
+	    ${MAKE} SSP_CFLAGS= -DNO_CPU_CFLAGS -DNO_CTF -DEARLY_BUILD WARNS=0 \
 	    -f ${KERNSRCDIR}/dev/aic7xxx/aicasm/Makefile
 # XXX - Gratuitously builds aicasm in the ``makeoptions NO_MODULES'' case.
 .if !defined(MODULES_WITH_WORLD) && !defined(NO_MODULES) && exists(${KERNSRCDIR}/modules)
@@ -787,9 +803,12 @@
 	cd ${KERNSRCDIR}/modules/aic7xxx/aicasm; \
 	    PATH=${BPATH}:${PATH} \
 	    MAKEOBJDIRPREFIX=${KRNLOBJDIR}/${_kernel}/modules \
-	    ${MAKE} SSP_CFLAGS= -DNO_CPU_CFLAGS -DNO_CTF ${target}
+	    MAKEINCPATH=${WORLDTMP}/usr/include \
+	    ${MAKE} SSP_CFLAGS= -DNO_CPU_CFLAGS -DNO_CTF -DEARLY_BUILD WARNS=0 \
+	    ${target}
 .endfor
 .endif
+	${_+_}cd ${.CURDIR}; ${KTMAKE} kernel-tools
 .if !defined(NO_KERNELDEPEND)
 	@echo
 	@echo "--------------------------------------------------------------"
@@ -982,8 +1001,10 @@
     ${_gperf} \
     ${_groff} \
     ${_ar} \
-    ${_yacc} \
-    ${_lex} \
+    lib/liby \
+    usr.bin/yacc \
+    usr.bin/lex \
+    gnu/usr.bin/patch \
     usr.bin/lorder \
     usr.bin/makewhatis \
     ${_mklocale} \
@@ -1047,6 +1068,14 @@
 .endfor
 
 #
+# kernel-tools: Build kernel-building tools
+#
+kernel-tools: .MAKE
+	mkdir -p ${MAKEOBJDIRPREFIX}/usr
+	mtree -deU -f ${.CURDIR}/etc/mtree/BSD.usr.dist \
+	    -p ${MAKEOBJDIRPREFIX}/usr >/dev/null
+
+#
 # cross-tools: Build cross-building tools
 #
 .if ${TARGET_ARCH} != ${MACHINE_ARCH} || ${BOOTSTRAPPING} < 800035
@@ -1084,7 +1113,7 @@
 		cd ${.CURDIR}/${_tool}; \
 		${MAKE} DIRPRFX=${_tool}/ obj; \
 		${MAKE} DIRPRFX=${_tool}/ depend; \
-		${MAKE} DIRPRFX=${_tool}/ all; \
+		${MAKE} DIRPRFX=${_tool}/ COPTS=-O0 all; \
 		${MAKE} DIRPRFX=${_tool}/ DESTDIR=${MAKEOBJDIRPREFIX} install
 .endfor
 

Index: release/Makefile
===================================================================
--- release/Makefile	(revision 261329)
+++ release/Makefile	(working copy)
@@ -556,7 +556,7 @@
 	echo "fi"				>> ${_MK}
 	echo "if [ ! -f /tmp/.world_done ]; then" >> ${_MK}
 	echo "	cd /usr/src"			>> ${_MK}
-	echo "	${CROSSMAKE} ${WORLD_FLAGS} -DNO_CLEAN buildworld && \\" >> ${_MK}
+	echo "	${CROSSMAKE} ${WORLD_FLAGS:N-j*} -DNO_CLEAN buildworld && \\" >> ${_MK}
 	echo "	touch /tmp/.world_done || exit 1" >> ${_MK}
 	echo "fi"				>> ${_MK}
 	echo "if [ ! -f /tmp/.skip_ports_index ]; then" >> ${_MK}
Index: contrib/gcc/toplev.h
===================================================================
--- contrib/gcc/toplev.h	(revision 261329)
+++ contrib/gcc/toplev.h	(working copy)
@@ -158,6 +158,7 @@
 extern int floor_log2                  (unsigned HOST_WIDE_INT);
 
 /* Inline versions of the above for speed.  */
+#ifndef __llvm__
 #if GCC_VERSION >= 3004
 # if HOST_BITS_PER_WIDE_INT == HOST_BITS_PER_LONG
 #  define CLZ_HWI __builtin_clzl
@@ -182,6 +183,7 @@
   return x == (x & -x) && x ? (int) CTZ_HWI (x) : -1;
 }
 #endif /* GCC_VERSION >= 3004 */
+#endif /* !__llvm__ */
 
 /* Functions used to get and set GCC's notion of in what directory
    compilation was started.  */
Index: share/mk/bsd.dep.mk
===================================================================
--- share/mk/bsd.dep.mk	(revision 261329)
+++ share/mk/bsd.dep.mk	(working copy)
@@ -102,8 +102,8 @@
 CLEANFILES+= y.tab.c y.tab.h
 .elif !empty(YFLAGS:M-d)
 .for _YH in ${_YC:R}.h
-.ORDER: ${_YC} ${_YH}
-${_YC} ${_YH}: ${_YSRC}
+${_YH}: ${_YC}
+${_YC}: ${_YSRC}
 	${YACC} ${YFLAGS} -o ${_YC} ${.ALLSRC}
 SRCS+=	${_YH}
 CLEANFILES+= ${_YH}
@@ -128,15 +128,10 @@
 
 # Different types of sources are compiled with slightly different flags.
 # Split up the sources, and filter out headers and non-applicable flags.
-.if ${CC} == "icc"
-MKDEP_CFLAGS=	${CFLAGS:M-X*} ${CFLAGS:M-[BID]*}
-MKDEP_CXXFLAGS=	${CXXFLAGS:M-X*} ${CXXFLAGS:M-[BID]*}
-MKDEP_OBJCFLAGS=${OBJCFLAGS:M-X*} ${OBJCFLAGS:M-[BID]*}
-.else
-MKDEP_CFLAGS=	${CFLAGS:M-nostdinc*} ${CFLAGS:M-[BID]*}
-MKDEP_CXXFLAGS=	${CXXFLAGS:M-nostdinc*} ${CXXFLAGS:M-[BID]*}
-MKDEP_OBJCFLAGS=${OBJCFLAGS:M-nostdinc*} ${OBJCFLAGS:M-[BID]*} ${OBJCFLAGS:M-Wno-import*}
-.endif
+MKDEP_CFLAGS=	${CFLAGS:M-nostdinc*} ${CFLAGS:M-[BIDU]*} ${CFLAGS:M-std=*} \
+		${CFLAGS:M-ansi}
+MKDEP_CXXFLAGS=	${CXXFLAGS:M-nostdinc*} ${CXXFLAGS:M-[BIDU]*} \
+		${CXXFLAGS:M-std=*} ${CXXFLAGS:M-ansi} ${CXXFLAGS:M-stdlib=*}
 
 DPSRCS+= ${SRCS}
 ${DEPENDFILE}: ${DPSRCS}
@@ -151,10 +146,6 @@
 	    ${MKDEP_CXXFLAGS} \
 	    ${.ALLSRC:M*.cc} ${.ALLSRC:M*.C} ${.ALLSRC:M*.cpp} ${.ALLSRC:M*.cxx}
 .endif
-.if !empty(DPSRCS:M*.m)
-	${MKDEPCMD} -f ${DEPENDFILE} -a ${MKDEP} \
-	    ${MKDEP_OBJCFLAGS} ${.ALLSRC:M*.m}
-.endif
 .if target(_EXTRADEPEND)
 _EXTRADEPEND: .USE
 ${DEPENDFILE}: _EXTRADEPEND
Index: share/mk/bsd.prog.mk
===================================================================
--- share/mk/bsd.prog.mk	(revision 261329)
+++ share/mk/bsd.prog.mk	(working copy)
@@ -134,7 +134,7 @@
 .endif
 .else
 	echo ${PROG}: ${LIBC} ${DPADD} >> ${DEPENDFILE}
-.if defined(PROG_CXX)
+.if defined(PROG_CXX) && !defined(EARLY_BUILD)
 	echo ${PROG}: ${LIBSTDCPLUSPLUS} >> ${DEPENDFILE}
 .endif
 .endif
Index: sys/conf/files
===================================================================
--- sys/conf/files	(revision 261329)
+++ sys/conf/files	(working copy)
@@ -9,47 +9,6 @@
 	compile-with	"${AWK} -f $S/tools/acpi_quirks2h.awk $S/dev/acpica/acpi_quirks" \
 	no-obj no-implicit-rule before-depend				   \
 	clean		"acpi_quirks.h"
-aicasm				optional ahc | ahd			   \
-	dependency	"$S/dev/aic7xxx/aicasm/*.[chyl]"		   \
-	compile-with	"CC='${CC}' ${MAKE} -f $S/dev/aic7xxx/aicasm/Makefile MAKESRCPATH=$S/dev/aic7xxx/aicasm" \
-	no-obj no-implicit-rule						   \
-	clean		"aicasm* y.tab.h"
-aic7xxx_seq.h			optional ahc				   \
-	compile-with	"./aicasm ${INCLUDES} -I$S/cam/scsi -I$S/dev/aic7xxx -o aic7xxx_seq.h -r aic7xxx_reg.h -p aic7xxx_reg_print.c -i $S/dev/aic7xxx/aic7xxx_osm.h $S/dev/aic7xxx/aic7xxx.seq"   \
-	no-obj no-implicit-rule before-depend local			   \
-	clean		"aic7xxx_seq.h"					   \
-	dependency	"$S/dev/aic7xxx/aic7xxx.{reg,seq} $S/cam/scsi/scsi_message.h aicasm"
-aic7xxx_reg.h			optional ahc				   \
-	compile-with	"./aicasm ${INCLUDES} -I$S/cam/scsi -I$S/dev/aic7xxx -o aic7xxx_seq.h -r aic7xxx_reg.h -p aic7xxx_reg_print.c -i $S/dev/aic7xxx/aic7xxx_osm.h $S/dev/aic7xxx/aic7xxx.seq"   \
-	no-obj no-implicit-rule before-depend local			   \
-	clean		"aic7xxx_reg.h"					   \
-	dependency	"$S/dev/aic7xxx/aic7xxx.{reg,seq} $S/cam/scsi/scsi_message.h aicasm"
-aic7xxx_reg_print.c		optional ahc				   \
-	compile-with	"./aicasm ${INCLUDES} -I$S/cam/scsi -I$S/dev/aic7xxx -o aic7xxx_seq.h -r aic7xxx_reg.h -p aic7xxx_reg_print.c -i $S/dev/aic7xxx/aic7xxx_osm.h $S/dev/aic7xxx/aic7xxx.seq"   \
-	no-obj no-implicit-rule local					   \
-	clean		"aic7xxx_reg_print.c"				   \
-	dependency	"$S/dev/aic7xxx/aic7xxx.{reg,seq} $S/cam/scsi/scsi_message.h aicasm"
-aic7xxx_reg_print.o		optional ahc ahc_reg_pretty_print	   \
-	compile-with	"${NORMAL_C}"					   \
-	no-implicit-rule local
-aic79xx_seq.h		optional ahd pci				   \
-	compile-with	"./aicasm ${INCLUDES} -I$S/cam/scsi -I$S/dev/aic7xxx -o aic79xx_seq.h -r aic79xx_reg.h -p aic79xx_reg_print.c -i $S/dev/aic7xxx/aic79xx_osm.h $S/dev/aic7xxx/aic79xx.seq"   \
-	no-obj no-implicit-rule before-depend local			   \
-	clean		"aic79xx_seq.h"					   \
-	dependency	"$S/dev/aic7xxx/aic79xx.{reg,seq} $S/cam/scsi/scsi_message.h aicasm"
-aic79xx_reg.h		optional ahd pci				   \
-	compile-with	"./aicasm ${INCLUDES} -I$S/cam/scsi -I$S/dev/aic7xxx -o aic79xx_seq.h -r aic79xx_reg.h -p aic79xx_reg_print.c -i $S/dev/aic7xxx/aic79xx_osm.h $S/dev/aic7xxx/aic79xx.seq"   \
-	no-obj no-implicit-rule before-depend local			   \
-	clean		"aic79xx_reg.h"					   \
-	dependency	"$S/dev/aic7xxx/aic79xx.{reg,seq} $S/cam/scsi/scsi_message.h aicasm"
-aic79xx_reg_print.c	optional ahd pci				   \
-	compile-with	"./aicasm ${INCLUDES} -I$S/cam/scsi -I$S/dev/aic7xxx -o aic79xx_seq.h -r aic79xx_reg.h -p aic79xx_reg_print.c -i $S/dev/aic7xxx/aic79xx_osm.h $S/dev/aic7xxx/aic79xx.seq"   \
-	no-obj no-implicit-rule local					   \
-	clean		"aic79xx_reg_print.c"				   \
-	dependency	"$S/dev/aic7xxx/aic79xx.{reg,seq} $S/cam/scsi/scsi_message.h aicasm"
-aic79xx_reg_print.o		optional ahd pci ahd_reg_pretty_print	   \
-	compile-with	"${NORMAL_C}"					   \
-	no-implicit-rule local
 feeder_eq_gen.h			optional sound				   \
 	dependency	"$S/tools/sound/feeder_eq_mkfilter.awk"		   \
 	compile-with	"${AWK} -f $S/tools/sound/feeder_eq_mkfilter.awk -- ${FEEDER_EQ_PRESETS} > feeder_eq_gen.h" \
@@ -469,16 +428,20 @@
 dev/aic/aic_pccard.c		optional aic pccard
 dev/aic7xxx/ahc_eisa.c		optional ahc eisa
 dev/aic7xxx/ahc_isa.c		optional ahc isa
-dev/aic7xxx/ahc_pci.c		optional ahc pci
-dev/aic7xxx/ahd_pci.c		optional ahd pci
+dev/aic7xxx/ahc_pci.c		optional ahc pci \
+	compile-with "${NORMAL_C} ${NO_WCONSTANT_CONVERSION}"
+dev/aic7xxx/ahd_pci.c		optional ahd pci \
+	compile-with "${NORMAL_C} ${NO_WCONSTANT_CONVERSION}"
 dev/aic7xxx/aic7770.c		optional ahc
 dev/aic7xxx/aic79xx.c		optional ahd pci
 dev/aic7xxx/aic79xx_osm.c	optional ahd pci
 dev/aic7xxx/aic79xx_pci.c	optional ahd pci
+dev/aic7xxx/aic79xx_reg_print.c	optional ahd pci ahd_reg_pretty_print
 dev/aic7xxx/aic7xxx.c		optional ahc
 dev/aic7xxx/aic7xxx_93cx6.c	optional ahc
 dev/aic7xxx/aic7xxx_osm.c	optional ahc
 dev/aic7xxx/aic7xxx_pci.c	optional ahc pci
+dev/aic7xxx/aic7xxx_reg_print.c	optional ahc ahc_reg_pretty_print
 dev/alc/if_alc.c		optional alc pci inet
 dev/ale/if_ale.c		optional ale pci inet
 dev/amd/amd.c			optional amd
Index: sys/dev/aic7xxx/aicasm/aicasm_scan.l
===================================================================
--- sys/dev/aic7xxx/aicasm/aicasm_scan.l	(revision 261329)
+++ sys/dev/aic7xxx/aicasm/aicasm_scan.l	(working copy)
@@ -76,6 +76,8 @@
 extern void mm_delete_buffer(YY_BUFFER_STATE);
 %}
 
+%option noinput
+
 PATH		([/]*[-A-Za-z0-9_.])+
 WORD		[A-Za-z_][-A-Za-z_0-9]*
 SPACE		[ \t]+
Index: sys/dev/aic7xxx/aicasm/aicasm_macro_scan.l
===================================================================
--- sys/dev/aic7xxx/aicasm/aicasm_macro_scan.l	(revision 261329)
+++ sys/dev/aic7xxx/aicasm/aicasm_macro_scan.l	(working copy)
@@ -70,6 +70,8 @@
 extern int mmlex(void);
 %}
 
+%option noinput
+
 WORD		[A-Za-z_][-A-Za-z_0-9]*
 SPACE		[ \t]+
 MCARG		[^(), \t]+
Index: sys/dev/aic7xxx/aicasm/Makefile
===================================================================
--- sys/dev/aic7xxx/aicasm/Makefile	(revision 261329)
+++ sys/dev/aic7xxx/aicasm/Makefile	(working copy)
@@ -30,10 +30,13 @@
 .else
 NOSTDINC=	-nostdinc
 .endif
-CFLAGS+= ${NOSTDINC} -I/usr/include -I.
+CFLAGS+= ${NOSTDINC} -I.
 .ifdef MAKESRCPATH
 CFLAGS+= -I${MAKESRCPATH}
 .endif
+.ifdef MAKEINCPATH
+CFLAGS+= -I${MAKEINCPATH}
+.endif
 NO_MAN=
 YFLAGS= -b ${.TARGET:R} ${.TARGET:M*macro*:S/$(.TARGET)/-p mm/} -d
 LFLAGS+= ${.TARGET:M*macro*:S/$(.TARGET)/-Pmm/}
Index: sys/dev/aic7xxx/aicasm/aicasm.c
===================================================================
--- sys/dev/aic7xxx/aicasm/aicasm.c	(revision 261329)
+++ sys/dev/aic7xxx/aicasm/aicasm.c	(working copy)
@@ -530,7 +530,7 @@
 	int instrptr;
 	unsigned int line;
 	int func_count;
-	int skip_addr;
+	unsigned int skip_addr;
 
 	instrcount = 0;
 	instrptr = 0;
Index: sys/modules/aic7xxx/ahc/ahc_pci/Makefile
===================================================================
--- sys/modules/aic7xxx/ahc/ahc_pci/Makefile	(revision 261329)
+++ sys/modules/aic7xxx/ahc/ahc_pci/Makefile	(working copy)
@@ -4,13 +4,13 @@
 .PATH:	${.CURDIR}/../../../../dev/aic7xxx
 KMOD=	ahc_pci
 
-../aic7xxx_reg.h:
-	( cd .. ; ${MAKE} aic7xxx_reg.h )
-
-SRCS=	ahc_pci.c aic7xxx_pci.c ../aic7xxx_reg.h
+SRCS=	ahc_pci.c aic7xxx_pci.c
 SRCS+=	device_if.h bus_if.h pci_if.h
 SRCS+=	opt_scsi.h opt_cam.h opt_aic7xxx.h
 
 CFLAGS+= -I${.CURDIR}/../../../../dev/aic7xxx -I..
 
 .include <bsd.kmod.mk>
+
+CWARNFLAGS.ahc_pci.c=	${NO_WCONSTANT_CONVERSION}
+CWARNFLAGS+=		${CWARNFLAGS.${.IMPSRC:T}}
Index: sys/modules/aic7xxx/ahc/ahc_isa/Makefile
===================================================================
--- sys/modules/aic7xxx/ahc/ahc_isa/Makefile	(revision 261329)
+++ sys/modules/aic7xxx/ahc/ahc_isa/Makefile	(working copy)
@@ -4,15 +4,10 @@
 .PATH:	${.CURDIR}/../../../../dev/aic7xxx
 KMOD=		ahc_isa
 
-../aic7xxx_reg.h:
-	( cd .. ; ${MAKE} aic7xxx_reg.h )
-
-SRCS=	ahc_isa.c ../aic7xxx_reg.h
+SRCS=	ahc_isa.c
 SRCS+=	device_if.h bus_if.h pci_if.h isa_if.h
 SRCS+=	opt_scsi.h opt_cam.h opt_aic7xxx.h
 
 CFLAGS+=	-I${.CURDIR}/../../../../dev/aic7xxx -I..
 
-CLEANFILES=	../aic7xxx_reg.h ../aic7xxx_seq.h
-
 .include <bsd.kmod.mk>
Index: sys/modules/aic7xxx/ahc/ahc_eisa/Makefile
===================================================================
--- sys/modules/aic7xxx/ahc/ahc_eisa/Makefile	(revision 261329)
+++ sys/modules/aic7xxx/ahc/ahc_eisa/Makefile	(working copy)
@@ -4,15 +4,10 @@
 .PATH:	${.CURDIR}/../../../../dev/aic7xxx
 KMOD=		ahc_eisa
 
-../aic7xxx_reg.h:
-	( cd .. ; ${MAKE} aic7xxx_reg.h )
-
-SRCS=	ahc_eisa.c ../aic7xxx_reg.h
+SRCS=	ahc_eisa.c
 SRCS+=	device_if.h bus_if.h eisa_if.h
 SRCS+=	opt_scsi.h opt_cam.h opt_aic7xxx.h
 
 CFLAGS+=	-I${.CURDIR}/../../../../dev/aic7xxx -I..
 
-CLEANFILES=	../aic7xxx_reg.h ../aic7xxx_seq.h
-
 .include <bsd.kmod.mk>
Index: sys/modules/aic7xxx/ahc/Makefile
===================================================================
--- sys/modules/aic7xxx/ahc/Makefile	(revision 261329)
+++ sys/modules/aic7xxx/ahc/Makefile	(working copy)
@@ -15,9 +15,11 @@
 .endif
 BEFORE_DEPEND = ${GENSRCS}
 
-../aicasm/aicasm: ${.CURDIR}/../../../dev/aci7xxx/aicasm/*.[chyl]
+../aicasm/aicasm: ${.CURDIR}/../../../dev/aic7xxx/aicasm/*.[chyl]
 	( cd ${.CURDIR}/../aicasm; ${MAKE} aicasm; )
 
+.if make(ahcfirmware)
+ahcfirmware: ${GENSRCS}
 ${GENSRCS}:								 \
 		${.CURDIR}/../../../dev/aic7xxx/aic7xxx.{reg,seq}	 \
 		${.CURDIR}/../../../cam/scsi/scsi_message.h ../aicasm/aicasm
@@ -27,12 +29,17 @@
 			${REG_PRINT_OPT}				 \
 			-i ${.CURDIR}/../../../dev/aic7xxx/aic7xxx_osm.h \
 			${.CURDIR}/../../../dev/aic7xxx/aic7xxx.seq
+.endif
 
+
 SRCS= ${GENSRCS}
 SRCS+= aic7xxx.c aic7xxx_93cx6.c aic7xxx_osm.c aic7770.c
 SRCS+= opt_scsi.h opt_aic7xxx.h opt_cam.h
 SRCS+= device_if.h bus_if.h pci_if.h
 
+.if make(cleanfirmware)
+cleanfirmware: clean
 CLEANFILES= ${GENSRCS}
+.endif
 
 .include <bsd.kmod.mk>
Index: sys/modules/aic7xxx/ahd/Makefile
===================================================================
--- sys/modules/aic7xxx/ahd/Makefile	(revision 261329)
+++ sys/modules/aic7xxx/ahd/Makefile	(working copy)
@@ -18,6 +18,8 @@
 ../aicasm/aicasm: ${.CURDIR}/../../../dev/aic7xxx/aicasm/*.[chyl]
 	( cd ${.CURDIR}/../aicasm; ${MAKE} aicasm; )
 
+.if make(ahdfirmware)
+ahdfirmware: ${GENSRCS}
 ${GENSRCS}:								 \
 		${.CURDIR}/../../../dev/aic7xxx/aic79xx.{reg,seq}	 \
 		${.CURDIR}/../../../cam/scsi/scsi_message.h ../aicasm/aicasm
@@ -27,12 +29,20 @@
 			${REG_PRINT_OPT}				 \
 			-i ${.CURDIR}/../../../dev/aic7xxx/aic79xx_osm.h \
 			${.CURDIR}/../../../dev/aic7xxx/aic79xx.seq
+.endif
 
+
 SRCS= ${GENSRCS}
 SRCS+= aic79xx.c aic79xx_osm.c aic79xx_pci.c ahd_pci.c
 SRCS+= opt_scsi.h opt_aic79xx.h opt_cam.h opt_ddb.h
 SRCS+= device_if.h bus_if.h pci_if.h
 
+.if make(cleanfirmware)
+cleanfirmware: clean
 CLEANFILES= ${GENSRCS}
+.endif
 
 .include <bsd.kmod.mk>
+
+CWARNFLAGS.ahd_pci.c=	${NO_WCONSTANT_CONVERSION}
+CWARNFLAGS+=		${CWARNFLAGS.${.IMPSRC:T}}
Index: sys/modules/aic7xxx/Makefile
===================================================================
--- sys/modules/aic7xxx/Makefile	(revision 261329)
+++ sys/modules/aic7xxx/Makefile	(working copy)
@@ -1,6 +1,22 @@
 
 # $FreeBSD$
 
-SUBDIR= aicasm ahc ahd
+SUBDIR= ahc ahd
 
+firmware: aicasm/aicasm ahdfirmware ahcfirmware
+
+aicasm/aicasm:
+	( cd ${.CURDIR}/aicasm ; ${MAKE} aicasm )
+
+ahdfirmware:
+	( cd ${.CURDIR}/ahd ; ${MAKE} ahdfirmware )
+
+ahcfirmware:
+	( cd ${.CURDIR}/ahc ; ${MAKE} ahcfirmware )
+
+cleanfirmware:
+	( cd .${CURDIR}/aicasm ; ${MAKE} clean )
+	( cd .${CURDIR}/ahc ; ${MAKE} cleanfirmware )
+	( cd .${CURDIR}/ahd ; ${MAKE} cleanfirmware )
+
 .include <bsd.subdir.mk>
